@echo off
rem INSTALLATION BATCH FOR POWERLINE VERSION 3
rem WRITTEN BY MART VAN INEVELD
if not exist pwl.com goto syntax_error
if "%2"=="OK" goto start_install
:loadPwl
cls
echo.
echo PowerLine will execute this batch file for itself.
echo PowerLine is loading...
echo.
pwl /h:0 /a:0 /c install.bat %1 OK
goto exit


:start_install
rem First check if PowerLine for DOS is running:
if not "%pwl_present%"=="ON" goto loadPwl

rem MAIN INSTALLATION PART WITH POWERLINE EXTENSIONS...
rem cls
echo ******************************************************************
echo *  Installation of PowerLine for Windows and MS-DOS version 3.0  *
echo ******************************************************************
echo *  PowerLine for DOS is executing this installation batch file   *
echo *  without any external commands...                              *
echo ******************************************************************
echo.

set Destin=%1

:checkEmpty
if not "%Destin%"=="" goto checkDir
:enter_dir
echo.
input/d Enter the directory to install PowerLine:_
set Destin=%pwl_input%
goto checkEmpty

:root_error
echo.
echo ERROR: Destination is not a full directory name (like "C:\PWL").
goto enter_dir

:checkDir
set destin=%@upper[%destin%]%
set source=%@upper[%@path[%0]%]%
if %@len[%source%]%==3 goto sourceCheck
set source=%@substr[%source%,0,%@eval[%@len[%source%]%-1]%]%
:sourceCheck
if not %source%==%destin% goto sourceOk
echo ERROR: Source directory may not be equal to destination directory.
goto enter_dir

:sourceOk
set source=
if not %@substr[%destin%,1,1]%==: goto root_error
if not %@substr[%destin%,2,1]%==\ goto root_error
if not exist %Destin%\nul goto dir_Error
if not %@len[%destin%]%==3 goto install
echo.
echo WARNING: Destination is a root directory.
inkey/d Continue anyway (y/n)?_
case %pwl_inkey%
  "Y": goto install
else
  goto enter_dir
endcase


:install
echo.
inkey/d Install PowerLine for Windows (y/n)?_
set winpwl=%@upper[%pwl_inkey%]%
inkey/d Install PowerLine for DOS (y/n)?_
set dospwl=%@upper[%pwl_inkey%]%


if not "%dospwl%"=="Y" goto install_win
echo.
echo ******************************************************************
echo * Installing PowerLine for DOS in %destin%...                    
echo ******************************************************************
copy pwl.com %destin%>nul
copy pwl.ovl %destin%>nul
copy pwl.pif %destin%>nul
copy pwlhelp.* %destin%>nul
copy *.set %destin%>nul
copy dos.hlp %destin%>nul
set todisk=%@substr[%destin%,0,1]%:
set autoname=%todisk%\autoexec.scp
copy autoexec.scp %todisk%\ >nul

rem If COMSPEC<>PWL: create AUTOEXEC.SCP AND LOADDOS.SCP
if not %@index[%@upper[%comspec%]%,PWL]%==-1 goto complete
rem Files are copied now. Create LOADDOS.SCP..
set loaddos=%destin%\loaddos.scp

echo Creating utility script %loaddos%
echo @echo off>%loaddos%
echo if not %%1x==x goto loaddoscli>>%loaddos%
echo echo Syntax error. Usage: LOADDOS cmd>>%loaddos%
echo echo               Where: cmd is any valid command.>>%loaddos%
echo goto exit>>%loaddos%
echo :loaddoscli>>%loaddos%
echo push>>%loaddos%
echo set comspec=%comspec%>>%loaddos%
echo %%comspec%%/c%%1 %%2 %%3 %%4 %%5 %%6 %%7 %%8>>%loaddos%
echo pop>>%loaddos%
echo :exit>>%loaddos%


rem In the next lines, AUTOEXEC.SCP is modified somewhat:
echo Modifying the start-up script %autoname%...

rem Alias MOVE depends on presence of MOVE.EXE in path:
if %@search[move.exe]%x==x goto skipMove
echo alias move=%@search[move.exe]% >> %autoname%
:skipMove

if not %@search[help]%x==x goto helpFound
echo alias help=%destin%\pwlhelp.exe>>%autoname%
goto skipHelp
:helpFound
copy phelp.scp %destin%>nul
set phelp=%destin%\phelp.scp 
echo alias help=call %phelp%>>%autoname%
echo   %destin%\pwlhelp.exe %%1 >>%phelp%
echo endcase>>%phelp%
:skipHelp
echo alias pwlhelp=%destin%\pwlhelp.exe>>%autoname%

echo alias loaddos=call %loaddos%>>%autoname%
if %@search[format]%x==x goto skipFormat
echo alias format=loaddos %@search[format]%>>%autoname%
:skipFormat
if %@search[dosshell]%x==x goto skipDShell
echo alias dosshell=loaddos %@search[dosshell]%>>%autoname%
:skipDShell


:install_win
if not "%winpwl%"=="Y" goto exit
echo.
echo ******************************************************************
echo * Installing PowerLine for Windows in %destin%...                
echo ******************************************************************
copy winpwl.* %destin%>nul
copy *.wri %destin%  >nul
copy register.txt %destin%>nul

rem Check if DLL's have to be copied:
set windir=%@search[win.com]%
if %windir%x==x goto copyDLL
set windir=%@substr[%windir%,0,%@eval[%@len[%windir%]%-7]%]%
if exist %windir%system\shell.dll goto skipDLL
:copyDLL
copy *.dll %destin%>nul
:skipDLL
copy first.dum %destin%>nul
copy *.wb %destin%>nul


cdd %destin%

:complete
echo.
echo ******************************************************************
echo * PowerLine has been installed in %destin%                       
echo ******************************************************************
if not "%dospwl%"=="Y" goto completedWin
echo Start PowerLine for MS-DOS with the command:
echo       ">pwl"
:completedWin
if not "%winpwl%"=="Y" goto exit
echo Start PowerLine for Windows with:
echo       ">win winpwl"
cdd %destin%
goto exit


:dir_Error
echo.
echo Warning: Destination directory %destin% does not exist.
inkey/d Create the directory %destin% (y/n)?_
case %pwl_inkey%
  "Y": md %destin%
       goto checkDir
else
       echo.
       inkey/d Enter a new directory name (y/n)?_
       case %pwl_inkey%
         "Y": goto enter_dir
       else
         echo Installation not completed.
       endcase
endcase
goto exit


:syntax_error
echo Error: Install PowerLine from the directory where all unzipped files
echo        are present. 
echo For instance with the commands:
echo    ">CD \COMM\LOAD"
echo    ">INSTALL C:\PWLDIR"

:exit
