#include <conio.h>
#include <dir.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

char configfile[MAXPATH];
FILE *cfg;

struct {
        int configurations;
        int standard;
       } header;
             
struct {
        char autoexec_bat[MAXPATH];
        char config_sys[MAXPATH];
        char description[51];
        char short_name[17];
       } config[100];

void closefile()

{
 fclose(cfg);
}

int copy (char *from, char *to)

{
 /* Returns: 0 - No errors
             1 - Error in FROM-file
             2 - Error in TO-file
 */
 int ch;
 ldiv_t parts;
 unsigned long size;
 unsigned long blockcount;
 int number;
 char buffer[32768L];
 int infile;
 int outfile;

 // if 'to'-file exists, delete it
 if (file_exists(to))
  {
   _chmod(to, 1, 0);
   unlink(to);
  }

 // Open 'from'-file

 infile=open(from, O_RDONLY | O_BINARY);
 if (infile==-1) return 1;
 outfile=open(to, O_CREAT | O_BINARY);
 if (outfile==-1)
  {
   close(infile);
   return 2;
  }
 size=filelength(infile);

 parts=ldiv(size,32768L);

 // Start copying
 blockcount=0;
 while (blockcount<parts.quot)
  {
   if (read(infile, buffer, (unsigned int)32768L) == -1) 
    {
     close(infile); close(outfile);
     return 1;
    }
   if (write(outfile, buffer, (unsigned int)32768L) == -1)
    {
     close(infile); close(outfile);
     return 2;
    }
   blockcount++;
  }
 if (read(infile, buffer, (unsigned int)parts.rem) == -1)
  {                                                   
   close(infile); close(outfile);
   return 1;
  }
 if (write(outfile, buffer, (unsigned int)parts.rem) == -1)
  {
   close(infile); close(outfile);
   return 2;
  }
 close(infile); close(outfile);
 _chmod(to, 1, 0);
 return 0;
}

int file_exists(char *filename)

{
 return (access(filename, 0) == 0);
}

void getrundir(char *fn)

{
 char drive[MAXDRIVE];
 char dir[MAXDIR];
 char file[MAXFILE];
 char ext[MAXEXT];
 
 fnsplit(fn, drive, dir, file, ext);

 fnmerge(configfile, drive, dir, "MULTICNF", ".CFG");
}

int readconfigfile()

{
 /* Returns: 0 - No errors
             1 - Error opening/reading configuration file
 */

 char buffer[40];
 int cfg_nr;

 cfg=fopen(configfile, "rb");
 if (cfg==NULL)
  return 1;

 if (fread(&buffer, 39, 1, cfg) != 1)
  return 1;
 buffer[39]=0;

 if (fread(&header, sizeof(header), 1, cfg) != 1)
  return 1;

 for (cfg_nr=0;cfg_nr<header.configurations;cfg_nr++)
  {
   if (fread(&config[cfg_nr], sizeof(config[0]), 1, cfg) != 1)
    return 1;
  }

 closefile();
 return 0;
}

void useconfiguration(int cfgnr)

{
 time_t start, end;
 int olddiff, diff;

 copy("C:\\AUTOEXEC.BAT", "C:\\AUTOEXEC.MC");
 copy("C:\\CONFIG.SYS", "C:\\CONFIG.MC");
 _chmod("C:\\AUTOEXEC.BAT", 1, FA_ARCH);
 _chmod("C:\\CONFIG.SYS", 1, FA_ARCH);
 unlink("C:\\AUTOEXEC.BAT");
 unlink("C:\\CONFIG.SYS");
 if (strcmp(config[cfgnr].autoexec_bat, "**None**") != 0)
  {
   if (!file_exists(config[cfgnr].autoexec_bat))
    {
     printf("Autoexec.bat: %s does not exist!\n", config[cfgnr].autoexec_bat);
     exit(1);
    }
   if (copy(config[cfgnr].autoexec_bat, "C:\\AUTOEXEC.BAT"))
    {
     printf("Error copying %s to C:\\AUTOEXEC.BAT\n", config[cfgnr].autoexec_bat);
     copy("C:\\AUTOEXEC.MC", "C:\\AUTOEXEC.BAT");
     copy("C:\\CONFIG.MC", "C:\\CONFIG.SYS");
     exit(1);
    }
  }
 if (strcmp(config[cfgnr].config_sys, "**None**") != 0)
  {
   if (!file_exists(config[cfgnr].config_sys))
    {
     printf("Config.sys: %s does not exist!\n", config[cfgnr].config_sys);
     exit(1);
    }
   if (copy(config[cfgnr].config_sys, "C:\\CONFIG.SYS"))
    {
     printf("Error copying %s to C:\\CONFIG.SYS\n", config[cfgnr].config_sys);
     copy("C:\\AUTOEXEC.MC", "C:\\AUTOEXEC.BAT");
     copy("C:\\CONFIG.MC", "C:\\CONFIG.SYS");
     exit(1);
    }
  }
 // Files copied. Show message and, if not aborted, reboot
 textattr(0x07);
 cprintf("Rebooting using configuration %d\n\r\n", cfgnr+1);
 cprintf("Description  : ");
 textattr(0x0F); cprintf("%-.43s\n\r", config[cfgnr].description); textattr(0x07);
 cprintf("Short name   : ");
 textattr(0x0F); cprintf("%-.16s\n\r", config[cfgnr].short_name); textattr(0x07);
 cprintf("Autoexec.bat : ");
 textattr(0x0F); cprintf("%-.43s\n\r", config[cfgnr].autoexec_bat); textattr(0x07);
 cprintf("Config.sys   : ");
 textattr(0x0F); cprintf("%-.43s\n\r\n", config[cfgnr].config_sys); textattr(0x07);
 cprintf("Timer: ");
 textattr(0x0F); cprintf("05");
 textattr(0x07); cprintf(", Press ESC to abort, press a key to reboot.");
 gotoxy(10, wherey()); textattr(0x0F);

 start=time(NULL);
 end=time(NULL);
 olddiff=0;
 while ((end-start!=5) && (!kbhit()))
  {
   diff=(unsigned int)(end-start);
   if (diff!=olddiff)
    {
     gotoxy(wherex()-2, wherey());
     cprintf("%02d", 5-diff);
     olddiff=diff;
    }
   end=time(NULL);
  }
 textattr(0x07);
 if (kbhit())
  {
   switch(getch())
    {
     case 27: copy("C:\\AUTOEXEC.MC", "C:\\AUTOEXEC.BAT");
              copy("C:\\CONFIG.MC", "C:\\CONFIG.SYS");
              printf("\n\nABORTED!\n\n");
              exit(0);
     case  0: getch();
    }
  } 
 gotoxy(wherex()-2, wherey()); cprintf("00\n\r\n");
 cprintf("If your PC does not reboot after a few seconds,\n\r");
 cprintf("try pressing ");
 textattr(0x0F); cprintf("<CTRL>-<ALT>-<DEL>");
 textattr(0x07); cprintf(", if this doesn't\n\r");
 cprintf("work either, press ");
 textattr(0x0F); cprintf("RESET");
 textattr(0x07); cprintf(" or turn your PC off and\n\r");
 cprintf("back on. It will now reboot using the new\n\r");
 cprintf("configuration.\n\r\n");
  
 // Reboot
 __emit__(0xB8,0x10,0x4A,0xBB,0x00,0x00,0xCD,0x2F,0x3D,0xBE,0xBA,
          0x75,0x08,0xB8,0x10,0x4A,0xBB,0x02,0x00,0xCD,0x2F,0xEA,
          0x00,0x00,0xFF,0xFF);
 exit(0); // This should never be reached.
}

void main(int argc, char *argv[])

{
 printf("ResetSTD v1.1 - Copyright(C) 1994 by G. Veldman.\n\n");

 getrundir(argv[0]);
 if (!file_exists(configfile))
  {
   printf("Configuration file does not exist. Run CONFIG to create it.\n\n");
   exit(0);
  }
 if (readconfigfile())
  {
   printf("Error reading configuration file. Run CONFIG to (re)create it.\n\n");
   exit(0);
  }
 if (header.standard==-1)
  {
   printf("No standard configuration. First, use CONFIG and mark a configuration\n");
   printf("as standard.\n\n");
   exit(0);
  }
 if (header.standard>header.configurations-1)
  {
   printf("Standard configuration does not exist. Run CONFIG and mark another\n");
   printf("configuration as standard.\n");
  }
 useconfiguration(header.standard);
}
